#!/usr/bin/perl
#
#
use English;
use strict 'vars';

use Win32::TieRegistry;

my $num_processors = get_num_processors();

#print "Number of processors: $num_processors \n";

print "$num_processors\n";

sub get_num_processors {
  my $h_reg_key_hardware;
  my $h_reg_key;
  my $num_procs = 0;
  my $proc_id = 0;
  my $proc_key;
  my @proc_value_names;
  my $proc_value_name;
  
  my $reg_section = "LMachine\\Hardware\\Description\\System\\CentralProcessor";
  
  $h_reg_key_hardware = new Win32::TieRegistry $reg_section, { Access=>KEY_READ, Delimiter=>"\\" } ;
  if( ! defined( $h_reg_key_hardware ) ) {
    die "get_num_procs_win.pl: cannot read windows registry $reg_section \n";
  }

  while( defined( $h_reg_key_hardware ) ) {
    $h_reg_key = $h_reg_key_hardware->Open( $proc_id, { Access=>KEY_READ, Delimiter=>"\\" } );
    if( defined( $h_reg_key ) ) {
      # make sure the processor key contains a value indentified by 'Identifier'.
      @proc_value_names = $h_reg_key->ValueNames;
      foreach $proc_value_name (@proc_value_names) {
        if( $proc_value_name eq 'Identifier' ) {
          $num_procs++;
        }
      }
      $proc_id++;
      undef $h_reg_key;
    }
    else {
      undef $h_reg_key_hardware;
    } 
  }
  
  return $num_procs;
}