/**
  \ingroup UTFexampleLibExternalInterfaces
  \file    Dummy.h
  \brief   This file contains the interface for class Dummy.
  \author  REPLACE_BY_AUTHOR
  \date    REPLACE_BY_DATE

  Copyright:
  REPLACE_BY_YEAR Fraunhofer Institute for Telecommunications, Heinrich-Hertz-Institut (HHI)
  The copyright of this software source code is the property of HHI.
  This software may be used and/or copied only with the written permission
  of HHI and in accordance with the terms and conditions stipulated
  in the agreement/contract under which the software has been supplied.
  The software distributed under this license is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either expressed or implied.

  This class, as a dummy class, should be deleted from the project
  and the repository data base. It is here to provide you with a compiling
  and running version of a DLL and a static lib and demonstrates the use
  of the export/import keyword UTFEXAMPLELIB_API which is required for
  all classes that are part of the library interface (which means that
  the header file needs to be in the include folder and methods of the
  class are intended to be called by a library user).
*/

#ifndef UTFEXAMPLELIB_DUMMY_H
#define UTFEXAMPLELIB_DUMMY_H

#include <iostream>
#include <string>

namespace UTFexampleLib {

/**
  \ingroup UTFexampleLibExternalInterfaces
  The Dummy class is only used to test the build process (this first sentence is the brief description).
  Furthermore it is a sample class showing you some doxygen documentation
  and how a class is put into the API for a DLL through UTFEXAMPLELIB_API.
  REMOVE it from your project.
*/
class UTFEXAMPLELIB_DECL Dummy
{
public:
  /// Constructor
  Dummy();

  /// Destructor
  virtual ~Dummy();

public:
  /**
    This method prints a hello world like string.
    This method is simply used for testing of the build process.
    It prints a text string and waits for you to press a key.
    \param[in]  rcString string that will be output.
    \retval     Void
		\pre        None
		\post       None
  */
  void printSomething( const std::string& rcString );

  /// Method adding two numbers used for the demonstration of boost UTF
  int addNumbers( const int iOperand1, const int iOperand2 );

private:
  unsigned int m_uiDummyMember; ///< Short doc for the DummyMember which is only used to show this doxygen comment
};

} // namespace UTFexampleLib

#endif // UTFEXAMPLELIB_DUMMY_H
