/**
  \ingroup UTFexampleLibExternalInterfaces
  \file    UTFexampleLibDecl.h
  \brief   This UTFexampleLibDecl.h file controls DLL export/import under windows
  \author  selinger@hhi.fraunhofer.de
  \date    3/3/2009

  Copyright:
  2009 Fraunhofer Institute for Telecommunications, Heinrich-Hertz-Institut (HHI)
  The copyright of this software source code is the property of HHI.
  This software may be used and/or copied only with the written permission
  of HHI and in accordance with the terms and conditions stipulated
  in the agreement/contract under which the software has been supplied.
  The software distributed under this license is distributed on an "AS IS" basis,

  This file shall not be used for any implementation stuff.
  This is the file included by users of the lib UTFexampleLib
 */

/// \cond NEVER_DOC
#ifndef UTFEXAMPLELIB_UTFEXAMPLELIBDECL_H
#define UTFEXAMPLELIB_UTFEXAMPLELIBDECL_H
/// \endcond

#if defined( _WIN32 )
# if defined( HHI_ALL_DYN_LINK ) || defined( UTFEXAMPLELIB_DYN_LINK )
#   ifdef UTFEXAMPLELIB_SOURCE
#     define UTFEXAMPLELIB_DECL __declspec(dllexport)
#   else
#     define UTFEXAMPLELIB_DECL __declspec(dllimport)
#   endif  // UTFEXAMPLELIB_SOURCE
# endif // DYN_LINK
#endif // _WIN32

#if !defined( UTFEXAMPLELIB_DECL )
# define UTFEXAMPLELIB_DECL
#endif

#endif // UTFEXAMPLELIB_UTFEXAMPLELIBDECL_H
