/**
  \ingroup UTFexampleLibExternalInterfaces
  \file    UTFexampleLibPch.h
  \brief   This file controls pre-compiled header usage under windows. It must not contain/include any code
  \author  selinger@hhi.fraunhofer.de
  \date    3/3/2009

  Copyright:
  2009 Fraunhofer Institute for Telecommunications, Heinrich-Hertz-Institut (HHI)
  The copyright of this software source code is the property of HHI.
  This software may be used and/or copied only with the written permission
  of HHI and in accordance with the terms and conditions stipulated
  in the agreement/contract under which the software has been supplied.
  The software distributed under this license is distributed on an "AS IS" basis,

  This file shall not be used for any implementation stuff.
  Under windows, this file is used in the project settings of the library
  to control the usage of pre-compiled headers in the Visual Studio.
  It can be seen quite similar as StdAfx.h usage in Microsoft projects.

  IT NEEDS TO BE INCLUDED AS THE VERY FIST INCLUDE IN EVERY .cpp FILE
  OF YOUR LIBRARY!!!
*/

/// \cond NEVER_DOC
#ifndef UTFEXAMPLELIB_UTFEXAMPLELIBPCH_H
#define UTFEXAMPLELIB_UTFEXAMPLELIBPCH_H
/// \endcond

// include global defines
#include "GlobalDefines/GlobalDefines.h"

#define UTFEXAMPLELIB_SOURCE
#include "UTFexampleLib/UTFexampleLibDecl.h"

#endif //UTFEXAMPLELIB_UTFEXAMPLELIBPCH_H
