// UTFsample2.cpp: implementation of the UTFsample2 class.
//
//////////////////////////////////////////////////////////////////////

#include "UTFexampleLibPch.h"

#include "UTFexampleLib/UTFsample2.h"
#include <cassert>
#include <exception>
#include <iostream>
#include <fstream>

namespace utfexamplelib 
{
  // -----------
  int UTFsample2::doAssert()
  {
    // here we simulate that some test runs into an assert
    assert( false );

    return 0;
  }

  // -----------
  int UTFsample2::addNumbersWithBug( const int iOperand1, const int iOperand2 )
  {
    int iResult;

    iResult = iOperand1 + iOperand2;

    if( 4 == iOperand2 )
    {
      // Here we simulate a bug that needs fixing a this is probably a piece of buggy/wrong code that we might find out when testing 
      iResult = iOperand1 + 0;
    }

    return iResult;
  }

  // -----------
  int UTFsample2::divideNumbersMayThrowException( const int iDivident, const int iDivisor )
  {
    int iResult;
    
    // this my throw a divide by zero exception
    iResult = iDivident / iDivisor;

    return iResult;
  }

  // -----------
  int UTFsample2::doThrowSample2Exception()
  {
    throw Sample2Exception();

    return 0;
  }

  // -----------
  int UTFsample2::doThrowOtherThanSample2Exception()
  {
    throw ( "-- Demonstration of throwing something other than the expected Sample2Exception --" );

    return 0;
  }

  bool UTFsample2::checkDataInFile( const std::string& rcFileName, const std::string& rcReferenceFileName )
  {
    std::string cRefString;
    std::string cTestString;

    { // read the ref data from file
      std::ifstream cIfStream;

      cIfStream.open( rcReferenceFileName.c_str(), std::ios::in );

      if( false == cIfStream.is_open() )
      {
        std::string cErrorString;
        cErrorString = "\nCould not open reference data file: " + rcReferenceFileName;
        throw( cErrorString );
      }

      // get the ref string
      cIfStream >> cRefString;

      cIfStream.close();
    }

    { // imagine that we first run some algorithm and write the result into an output file that we now are going to read in order to compare with the reference
      std::ifstream cIfStream;

      cIfStream.open( rcFileName.c_str(), std::ios::in );

      if( false == cIfStream.is_open() )
      {
        std::string cErrorString;
        cErrorString = "\nCould not open test data file: " + rcFileName;
        throw( cErrorString );
      }

      // get the ref string
      cIfStream >> cTestString;

      cIfStream.close();
    }

    
    if( cTestString == cRefString )
    {
      return true;
    }
    else
    {
      return false;
    }
  }
} // end namespace

