/**
\ingroup 
\file    SquareMeCuda.cpp
\brief   
\author  wolfgang.waizenegger@hhi.fraunhofer.de
\date    06/26/2009

Copyright:
2008 Fraunhofer Institute for Telecommunications, Heinrich-Hertz-Institut (HHI)
The copyright of this software source code is the property of HHI.
This software may be used and/or copied only with the written permission
of HHI and in accordance with the terms and conditions stipulated
in the agreement/contract under which the software has been supplied.
The software distributed under this license is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied.
*/

#include "CudaTestPch.h"
#include "SquareMeCuda.h"


SquareMeCuda::SquareMeCuda(void) 
  : m_cModuleName       ( "SquareMeCuda" )
  , m_bGpuInitialized   ( false )  
{}

SquareMeCuda::~SquareMeCuda(void) {}

int SquareMeCuda::initGpu( SquareMeCudaInitPar cPar )
{
  BOOST_ASSERT( false == m_bGpuInitialized );  
  BOOST_VERIFY( 0 == initGpu_SquareMeCuda( &cPar, &m_cDevMem ) );
  //BAO_LOG( m_cModuleName << "::initGpu" );

  m_bGpuInitialized = true;
  return 0;
}

int SquareMeCuda::uninitGpu()
{
  BOOST_ASSERT( true == m_bGpuInitialized );
  BOOST_VERIFY( 0 == uninitGpu_SquareMeCuda( &m_cDevMem ) );
  //BAO_LOG( m_cModuleName << "::uninitGpu" );

  m_bGpuInitialized = false;
  return 0;
}

void SquareMeCuda::squareMe(float* pfIn, float* pfOut, int iLength)
{
  /* PARANOIA */
  BOOST_ASSERT( true == m_bGpuInitialized );
  BOOST_ASSERT( NULL != pfIn && NULL != pfOut && 0 < iLength );

  SquareMe_CUDA( pfIn, pfOut, &m_cDevMem );     
}

