/**
\ingroup 
\file    SquareMeCuda.h
\brief   
\author  wolfgang.waizenegger@hhi.fraunhofer.de
\date    06/26/2009

Copyright:
2008 Fraunhofer Institute for Telecommunications, Heinrich-Hertz-Institut (HHI)
The copyright of this software source code is the property of HHI.
This software may be used and/or copied only with the written permission
of HHI and in accordance with the terms and conditions stipulated
in the agreement/contract under which the software has been supplied.
The software distributed under this license is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied.
*/

#ifndef SQUARE_ME_CUDA_H_062620091349
#define SQUARE_ME_CUDA_H_062620091349


#include "SquareMe.cuh"
#include <stdio.h>
#include <string>
#include <boost/assert.hpp>


class SquareMeCuda
{
public:
  SquareMeCuda(void);
  ~SquareMeCuda(void);

  int initGpu( SquareMeCudaInitPar cPar );
  int uninitGpu();

  void squareMe(float* pfIn, float* pfOut, int iLength);  

protected:
  std::string         m_cModuleName;
  bool                m_bGpuInitialized;
  SquareMeCudaDevMem  m_cDevMem;  
};


#endif // #ifndef SQUARE_ME_CUDA_H_062620091349
