/**
\ingroup 
\file    SquareMeGold.cpp
\brief   
\author  wolfgang.waizenegger@hhi.fraunhofer.de
\date    06/26/2009

Copyright:
2008 Fraunhofer Institute for Telecommunications, Heinrich-Hertz-Institut (HHI)
The copyright of this software source code is the property of HHI.
This software may be used and/or copied only with the written permission
of HHI and in accordance with the terms and conditions stipulated
in the agreement/contract under which the software has been supplied.
The software distributed under this license is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied.
*/


#include "CudaTestPch.h"
#include "SquareMeGold.h"


SquareMeGold::SquareMeGold(void) {}
SquareMeGold::~SquareMeGold(void) {}

void SquareMeGold::squareMe(float* pfIn, float* pfOut, unsigned int uiLength)
{
  /* PARANOIA */
  BOOST_ASSERT( NULL != pfIn && NULL != pfOut && 0 < uiLength );

  for (unsigned int  i=0; i < uiLength; i++)
  {
    pfOut[i]= pfIn[i]*pfIn[i];
  }
}

