/**
\ingroup 
\file    SquareMe_kernel.cu
\brief   
\author  wolfgang.waizenegger@hhi.fraunhofer.de
\date    06/26/2009

Copyright:
2008 Fraunhofer Institute for Telecommunications, Heinrich-Hertz-Institut (HHI)
The copyright of this software source code is the property of HHI.
This software may be used and/or copied only with the written permission
of HHI and in accordance with the terms and conditions stipulated
in the agreement/contract under which the software has been supplied.
The software distributed under this license is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied.
*/

#ifndef SQUAREME_KERNEL_CU_062620091100
#define SQUAREME_KERNEL_CU_062620091100


/* Kernel to square elements of the array on the GPU */
__global__ void squareMe_kernel(float* pfIn, float* pfOut, int iLength)
{
	int idx = blockIdx.x * blockDim.x + threadIdx.x;
  if ( idx < iLength) { pfOut[idx]= pfIn[idx]*pfIn[idx]; }
}


#endif // #ifndef SQUAREME_KERNEL_CU_062620091100