/**
  \ingroup UTFexampleLibTest
  \file    TestSuiteMyStuff.cpp
  \brief   This TestSuiteMyStuff.cpp file contains an optional additional test suite for the lib under test
  \author  selinger@hhi.fraunhofer.de
  \date    3/3/2009

  Group related test cases into test suites in (best in separate files) for ease of use when you have big libs with different components.
*/

/// 1. A must! As always I first need to include the precompiled header file
#include "UTFexampleLibTestPch.h"

/// 2. A must! This boost UTF header file must always be included. We use the static library variant of the UTF. It is not recommended to use the single header library variant
#include <boost/test/unit_test.hpp>

/// Include the header file(s) of the class(es) you want to test
#include "UTFexampleLib/Dummy.h"


// Second test suite in separate translation unit just to show how it works and is intended
BOOST_AUTO_TEST_SUITE( ts2_my_stuff ) 

BOOST_AUTO_TEST_CASE( tc1_dummy ) { UTFexampleLib::Dummy cDummy; BOOST_CHECK_EQUAL( cDummy.addNumbers( 4, 1 ), 5 ); }
BOOST_AUTO_TEST_CASE( tc2_dummy ) { UTFexampleLib::Dummy cDummy; BOOST_CHECK_EQUAL( cDummy.addNumbers( 4, 2 ), 6 ); }
BOOST_AUTO_TEST_CASE( tc3_dummy ) { UTFexampleLib::Dummy cDummy; BOOST_CHECK_EQUAL( cDummy.addNumbers( 4, 3 ), 7 ); }
BOOST_AUTO_TEST_CASE( tc4_dummy ) { UTFexampleLib::Dummy cDummy; BOOST_CHECK_EQUAL( cDummy.addNumbers( 4, 4 ), 8 ); } 

BOOST_AUTO_TEST_SUITE_END()

