/* ====================================================================================================================

  The copyright in this software is being made available under the license included below. 
  This software may be subject to other third party and contributor rights, including patent rights, and no such 
  rights are granted under this license.
 
  Copyright (c) 2010, Fraunhofer-Gesellschaft zur Foerderung der angewandten Forschung e.V.
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification, are permitted only for 
  the purpose of developing standards within the Joint Collaborative Team on Video Coding and for testing and
  promoting such standards. The following conditions are required to be met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and 
      the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and 
      the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the Fraunhofer-Gesellschaft zur Foerderung der angewandten Forschung e.V. nor the
      names of its contributors may be used to endorse or promote products derived from this software
      without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 * ====================================================================================================================
*/

#ifndef _CODINGSTATE_H__E43399A8_CF59_4184_984E_FAB9FC0DF52B__INCLUDED_
#define _CODINGSTATE_H__E43399A8_CF59_4184_984E_FAB9FC0DF52B__INCLUDED_

//#include <utility>
#include "VideoCommonLib/PlanePackage.h"
#include "VideoCommonLib/ReferencePicture.h"

// video namespace begin
VIDEO_NAMESPACE_BEGIN

class CabacContextModel;
class AccessUnitParameters;
template<class T> class ContextStore;

class CodingState
{
public:
  CodingState( const std::vector<const ReferencePlanePackage<Pel>*> apcRefPlaPas,
               const ContextStore<CabacContextModel>* pcCtxStore )
    : m_apcRefPlaPas( apcRefPlaPas )
    , m_pcCtxStore( pcCtxStore )
  {}
  ~CodingState();

  const std::vector<const ReferencePlanePackage<Pel>*>& getPlanePackagesForPrediction() const { return m_apcRefPlaPas; }
  const ContextStore<CabacContextModel>* getRefCtxStore() const { return m_pcCtxStore; }
  const ReferencePlanePackage<Pel>* getRefPlanePackage( PicOrderCnt cPoc ) const;

private:
  const std::vector<const ReferencePlanePackage<Pel>*> m_apcRefPlaPas;
  const ContextStore<CabacContextModel>* m_pcCtxStore;
};

// video namespace end
VIDEO_NAMESPACE_END

#endif // #ifndef _CODINGSTATE_H__E43399A8_CF59_4184_984E_FAB9FC0DF52B__INCLUDED_
