/* ====================================================================================================================

  The copyright in this software is being made available under the license included below. 
  This software may be subject to other third party and contributor rights, including patent rights, and no such 
  rights are granted under this license.
 
  Copyright (c) 2010, Fraunhofer-Gesellschaft zur Foerderung der angewandten Forschung e.V.
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification, are permitted only for 
  the purpose of developing standards within the Joint Collaborative Team on Video Coding and for testing and
  promoting such standards. The following conditions are required to be met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and 
      the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and 
      the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the Fraunhofer-Gesellschaft zur Foerderung der angewandten Forschung e.V. nor the
      names of its contributors may be used to endorse or promote products derived from this software
      without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 * ====================================================================================================================
*/

#ifndef _RESTRAFOCOMMON_H__E43399A8_CF59_4184_984E_FAB9FC0DF52B__INCLUDED_
#define _RESTRAFOCOMMON_H__E43399A8_CF59_4184_984E_FAB9FC0DF52B__INCLUDED_



// video namespace begin
VIDEO_NAMESPACE_BEGIN


class ResTrafoCommon
{
protected:
  ResTrafoCommon( UInt uiNumPlanes ) : m_aiQp( uiNumPlanes ) {}
  virtual ~ResTrafoCommon() {}

public:
  std::vector<int>& getQps() { return m_aiQp; }
  const std::vector<int>& getQps() const { return m_aiQp; }

private:
  std::vector<int> m_aiQp;
};

class QParameter
{
public :
  QParameter( int iQp )
    : m_iQp( iQp )
    , m_iPer( iQp/6 )
    , m_iRem( iQp%6 )
    , m_iBits( QP_BITS + m_iPer ) {}

  const int val()   const { return m_iQp;   }
  const int per()   const { return m_iPer;  }
  const int rem()   const { return m_iRem;  }
  const int bits()  const { return m_iBits; }

private:
  int m_iQp;
  int m_iPer;
  int m_iRem;
  int m_iBits;
};

// video namespace end
VIDEO_NAMESPACE_END

#endif // #ifndef _RESTRAFOCOMMON_H__E43399A8_CF59_4184_984E_FAB9FC0DF52B__INCLUDED_
