/* ====================================================================================================================

  The copyright in this software is being made available under the license included below. 
  This software may be subject to other third party and contributor rights, including patent rights, and no such 
  rights are granted under this license.
 
  Copyright (c) 2010, Fraunhofer-Gesellschaft zur Foerderung der angewandten Forschung e.V.
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification, are permitted only for 
  the purpose of developing standards within the Joint Collaborative Team on Video Coding and for testing and
  promoting such standards. The following conditions are required to be met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and 
      the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and 
      the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the Fraunhofer-Gesellschaft zur Foerderung der angewandten Forschung e.V. nor the
      names of its contributors may be used to endorse or promote products derived from this software
      without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 * ====================================================================================================================
*/

#ifndef __VIDEODECODERAPP_H_D65BE9B4_A8DA_11D3_AFE7_005004464B79
#define __VIDEODECODERAPP_H_D65BE9B4_A8DA_11D3_AFE7_005004464B79

#include "VideoCodecToolsLib/MSysLargeFile.h"

class VideoDecoderInstance;

class VideoDecoderApp
{
protected:
  VideoDecoderApp();
  virtual ~VideoDecoderApp();

public:
  static ErrVal runAlternative( int argc, char **argv, bool &rbExit );

  //! creates a new instance of VideoDecoderApp
  static ErrVal create( VideoDecoderApp*& rpcVideoDecoderApp );

  //! initializes the class 
  ErrVal init( int argc, char**argv );

  //! runs the encoder
  ErrVal go();

  //! destroys the VideoDecoderApp object
  ErrVal destroy();

private:
  void xDisplayUsage( char *pcArgv0 );

  VideoDecoderInstance *m_pcVideoDecoderInstance;
  std::vector<std::string> m_acBitstreams;
  LargeFile m_cDecoded;
  std::string m_cOverlayFilename;
  std::vector<LargeFile*> m_apcOverlay;
};


#endif //__VIDEODECODERAPP_H_D65BE9B4_A8DA_11D3_AFE7_005004464B79
