/* ====================================================================================================================

  The copyright in this software is being made available under the license included below. 
  This software may be subject to other third party and contributor rights, including patent rights, and no such 
  rights are granted under this license.
 
  Copyright (c) 2010, Fraunhofer-Gesellschaft zur Foerderung der angewandten Forschung e.V.
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification, are permitted only for 
  the purpose of developing standards within the Joint Collaborative Team on Video Coding and for testing and
  promoting such standards. The following conditions are required to be met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and 
      the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and 
      the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the Fraunhofer-Gesellschaft zur Foerderung der angewandten Forschung e.V. nor the
      names of its contributors may be used to endorse or promote products derived from this software
      without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 * ====================================================================================================================
*/

#include "VideoCodecToolsLibPch.h"
#include "VideoCodecToolsLib/MSysDefines.h"



const char   TypeLimits<char>::m_iMin   = -128;
const char   TypeLimits<char>::m_iMax   = 127;
const UChar  TypeLimits<UChar>::m_iMin  = 0;
const UChar  TypeLimits<UChar>::m_iMax  = 255;
const short  TypeLimits<short>::m_iMin  = -32768;
const short  TypeLimits<short>::m_iMax  = 32767;
const UShort TypeLimits<UShort>::m_iMin = 0;
const UShort TypeLimits<UShort>::m_iMax = 0xFFFF;
const int  TypeLimits<int>::m_iMin  = (-2147483647 - 1);
const int  TypeLimits<int>::m_iMax  = 2147483647;
const UInt TypeLimits<UInt>::m_iMin = 0;
const UInt TypeLimits<UInt>::m_iMax = 0xFFFFFFFFU;

#if defined ( MSYS_WIN32 )
const Int64  TypeLimits<Int64>::m_iMin  = -9223372036854775807i64 - 1i64;
const Int64  TypeLimits<Int64>::m_iMax  = 9223372036854775807i64;
#elif defined( MSYS_LINUX )
const Int64  TypeLimits<Int64>::m_iMin  = -9223372036854775807LL - 1LL;
const Int64  TypeLimits<Int64>::m_iMax  = 9223372036854775807LL;
#endif

const UInt64 TypeLimits<UInt64>::m_iMin = 0;

#if defined ( MSYS_WIN32 )
const UInt64 TypeLimits<UInt64>::m_iMax = 0xFFFFFFFFFFFFFFFFui64;
#elif defined( MSYS_LINUX )
const UInt64 TypeLimits<UInt64>::m_iMax = 0xFFFFFFFFFFFFFFFFULL;
#endif
