/* ====================================================================================================================

  The copyright in this software is being made available under the license included below. 
  This software may be subject to other third party and contributor rights, including patent rights, and no such 
  rights are granted under this license.
 
  Copyright (c) 2010, Fraunhofer-Gesellschaft zur Foerderung der angewandten Forschung e.V.
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification, are permitted only for 
  the purpose of developing standards within the Joint Collaborative Team on Video Coding and for testing and
  promoting such standards. The following conditions are required to be met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and 
      the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and 
      the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the Fraunhofer-Gesellschaft zur Foerderung der angewandten Forschung e.V. nor the
      names of its contributors may be used to endorse or promote products derived from this software
      without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 * ====================================================================================================================
*/

#if !defined(AFX_NALUNITPARSER_H__D5B74729_6F04_42E9_91AE_2E28937F9F3A__INCLUDED_)
#define AFX_NALUNITPARSER_H__D5B74729_6F04_42E9_91AE_2E28937F9F3A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "BitReaderIf.h"

// h264 namespace begin
VIDEO_NAMESPACE_BEGIN

typedef BitReaderIf<UInt> MyBitReaderIf;
typedef std::vector<UChar> NalUnit;
//!\ingroup H264DecoderLib
//!NalUnitParser
class NalUnitParser
{
public:
	NalUnitParser();
	virtual ~NalUnitParser();


  static ErrVal convert( std::vector<UChar>& rcRawData, const std::vector<UChar>& rcNalUnit);

  static ErrVal create( NalUnitParser*& rpcNalUnitParser );
  ErrVal init( MyBitReaderIf *pcBitReadBuffer );
  ErrVal uninit();
  ErrVal destroy();
  ErrVal initNalUnit( const NalUnit &rcNalUnit );

  NalUnitType getNalUnitType()      { return m_eNalUnitType; }
  NalRefIdc   getNalRefIdc()        { return m_eNalRefIdc; }

protected:
  static ErrVal xConvertPayloadToRBSP( std::vector<UChar>& rcRawData, const std::vector<UChar>& rcNalUnit );

protected:
  NalUnit m_cNalUnit;
  MyBitReaderIf     *m_pcBitReadBuffer;
  NalUnitType        m_eNalUnitType;
  NalRefIdc          m_eNalRefIdc;
};
// h264 namespace end
VIDEO_NAMESPACE_END

#endif // !defined(AFX_NALUNITPARSER_H__D5B74729_6F04_42E9_91AE_2E28937F9F3A__INCLUDED_)
